"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createContext = exports.createContextWithValue = void 0;
var React = require("react");
var symbolObservable_1 = require("./utils/symbolObservable");
var Context_1 = require("./components/Context");
function createUnimplemented(objectName) {
    var prefix = objectName ? objectName + "." : "";
    return function createUnimplemented(methodName) {
        return function unimplemented() {
            throw new Error("Unimplemented method: " + prefix + methodName);
        };
    };
}
function createContextWithValue(value) {
    return React.createContext(__assign({ dispatch: function (a) { return a; }, getState: function () { return value.state; } }, value));
}
exports.createContextWithValue = createContextWithValue;
function createContext(rootReducer, preloadedState, enhancer, displayName, global) {
    var _a;
    if (global === void 0) { global = false; }
    var unimplemented = createUnimplemented("Context(" + (displayName !== null && displayName !== void 0 ? displayName : "") + ")");
    var Context = createContextWithValue((_a = {
            enhancer: enhancer,
            reducer: rootReducer,
            state: preloadedState
        },
        _a[symbolObservable_1.SymbolObservable] = unimplemented(symbolObservable_1.SymbolObservable.toString()),
        _a));
    if (displayName) {
        Context.displayName = displayName;
    }
    if (global) {
        Context_1.setGlobalContext(Context);
    }
    return Context;
}
exports.createContext = createContext;
